Index: sasmodels/models/capped_cylinder.c
===================================================================
--- sasmodels/models/capped_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/capped_cylinder.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -84,4 +84,32 @@
 }
 
+static double
+radius_from_volume(double radius, double radius_cap, double length)
+{
+    const double vol_cappedcyl = form_volume(radius,radius_cap,length);
+    return cbrt(0.75*vol_cappedcyl/M_PI);
+}
+
+static double
+radius_from_totallength(double radius, double radius_cap, double length)
+{
+    const double hc = radius_cap - sqrt(radius_cap*radius_cap - radius*radius);
+    return 0.5*length + hc;
+}
+
+static double
+effective_radius(int mode, double radius, double radius_cap, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius, radius_cap, length);
+    } else if (mode == 2) {
+        return radius;
+    } else if (mode == 3) {
+        return 0.5*length;
+    } else {
+        return radius_from_totallength(radius, radius_cap,length);
+    }
+}
+
 static void
 Fq(double q,double *F1, double *F2, double sld, double solvent_sld,
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/capped_cylinder.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -137,4 +137,5 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "capped_cylinder.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","radius","half length","half total length"]
 
 def random():
Index: sasmodels/models/core_multi_shell.c
===================================================================
--- sasmodels/models/core_multi_shell.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_multi_shell.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -19,4 +19,31 @@
 }
 
+static double
+outer_radius(double core_radius, double fp_n, double thickness[])
+{
+  double r = core_radius;
+  int n = (int)(fp_n+0.5);
+  for (int i=0; i < n; i++) {
+    r += thickness[i];
+  }
+  return r;
+}
+
+static double
+effective_radius(int mode, double core_radius, double fp_n, double thickness[])
+{
+    if (mode == 1) {
+        double r = core_radius;
+        int n = (int)(fp_n+0.5);
+        for (int i=0; i < n; i++) {
+            r += thickness[i];
+        }
+        return r;
+        //return outer_radius(core_radius,fp_n,thickness);
+    } else {
+        return core_radius;
+    }
+}
+
 static void
 Fq(double q, double *F1, double *F2, double core_sld, double core_radius,
Index: sasmodels/models/core_multi_shell.py
===================================================================
--- sasmodels/models/core_multi_shell.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_multi_shell.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -100,4 +100,5 @@
 source = ["lib/sas_3j1x_x.c", "core_multi_shell.c"]
 have_Fq = True
+effective_radius_type = ["outer radius", "core radius"]
 
 def random():
@@ -144,8 +145,8 @@
     return np.asarray(z), np.asarray(rho)
 
-def ER(radius, n, thickness):
-    """Effective radius"""
-    n = int(n[0]+0.5)  # n is a control parameter and is not polydisperse
-    return np.sum(thickness[:n], axis=0) + radius
+#def ER(radius, n, thickness):
+#    """Effective radius"""
+#    n = int(n[0]+0.5)  # n is a control parameter and is not polydisperse
+#    return np.sum(thickness[:n], axis=0) + radius
 
 demo = dict(sld_core=6.4,
Index: sasmodels/models/core_shell_bicelle.c
===================================================================
--- sasmodels/models/core_shell_bicelle.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -34,4 +34,33 @@
 
     return t;
+}
+
+static double
+radius_from_volume(double radius, double thick_rim, double thick_face, double length)
+{
+    const double volume_bicelle = form_volume(radius,thick_rim,thick_face,length);
+    return cbrt(0.75*volume_bicelle/M_PI);
+}
+
+static double
+radius_from_diagonal(double radius, double thick_rim, double thick_face, double length)
+{
+    const double radius_tot = radius + thick_rim;
+    const double length_tot = length + 2.0*thick_face;
+    return sqrt(radius_tot*radius_tot + 0.25*length_tot*length_tot);
+}
+
+static double
+effective_radius(int mode, double radius, double thick_rim, double thick_face, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius, thick_rim, thick_face, length);
+    } else if (mode == 2) {
+        return radius + thick_rim;
+    } else if (mode == 3) {
+        return 0.5*length + thick_face;
+    } else {
+        return radius_from_diagonal(radius,thick_rim,thick_face,length);
+    }
 }
 
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -155,4 +155,5 @@
           "core_shell_bicelle.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","outer rim radius", "half outer thickness","half diagonal"]
 
 def random():
Index: sasmodels/models/core_shell_bicelle_elliptical.c
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -8,4 +8,38 @@
 {
     return M_PI*(r_minor+thick_rim)*(r_minor*x_core+thick_rim)*(length+2.0*thick_face);
+}
+
+static double
+radius_from_volume(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double volume_bicelle = form_volume(r_minor, x_core, thick_rim,thick_face,length);
+    return cbrt(0.75*volume_bicelle/M_PI);
+}
+
+static double
+radius_from_diagonal(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double radius_max = (x_core < 1.0 ? r_minor : x_core*r_minor);
+    const double radius_max_tot = radius_max + thick_rim;
+    const double length_tot = length + 2.0*thick_face;
+    return sqrt(radius_max_tot*radius_max_tot + 0.25*length_tot*length_tot);
+}
+
+static double
+effective_radius(int mode, double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(r_minor, x_core, thick_rim, thick_face, length);
+    } else if (mode == 2) {
+        return 0.5*r_minor*(1.0 + x_core) + thick_rim;
+    } else if (mode == 3) {
+        return (x_core < 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    } else if (mode == 4) {
+        return (x_core > 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    } else if (mode ==5) {
+        return 0.5*length + thick_face;
+    } else {
+        return radius_from_diagonal(r_minor,x_core,thick_rim,thick_face,length);
+    }
 }
 
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -147,4 +147,6 @@
           "core_shell_bicelle_elliptical.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","outer rim average radius","outer rim min radius",
+                         "outer max radius", "half outer thickness","half diagonal"]
 
 def random():
Index: sasmodels/models/core_shell_bicelle_elliptical_belt_rough.c
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical_belt_rough.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical_belt_rough.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -9,4 +9,38 @@
     return M_PI*(  (r_minor + thick_rim)*(r_minor*x_core + thick_rim)* length +
                  square(r_minor)*x_core*2.0*thick_face  );
+}
+
+static double
+radius_from_volume(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double volume_bicelle = form_volume(r_minor, x_core, thick_rim,thick_face,length);
+    return cbrt(0.75*volume_bicelle/M_PI);
+}
+
+static double
+radius_from_diagonal(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double radius_max = (x_core < 1.0 ? r_minor : x_core*r_minor);
+    const double radius_max_tot = radius_max + thick_rim;
+    const double length_tot = length + 2.0*thick_face;
+    return sqrt(radius_max_tot*radius_max_tot + 0.25*length_tot*length_tot);
+}
+
+static double
+effective_radius(int mode, double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(r_minor, x_core, thick_rim, thick_face, length);
+    } else if (mode == 2) {
+        return 0.5*r_minor*(1.0 + x_core) + thick_rim;
+    } else if (mode == 3) {
+        return (x_core < 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    } else if (mode == 4) {
+        return (x_core > 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    } else if (mode ==5) {
+        return 0.5*length + thick_face;
+    } else {
+        return radius_from_diagonal(r_minor,x_core,thick_rim,thick_face,length);
+    }
 }
 
Index: sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -160,4 +160,6 @@
           "core_shell_bicelle_elliptical_belt_rough.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","outer rim average radius","outer rim min radius",
+                         "outer max radius", "half outer thickness","half diagonal"]
 
 demo = dict(scale=1, background=0,
Index: sasmodels/models/core_shell_cylinder.c
===================================================================
--- sasmodels/models/core_shell_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_cylinder.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -11,4 +11,37 @@
 {
     return M_PI*square(radius+thickness)*(length+2.0*thickness);
+}
+
+static double
+radius_from_volume(double radius, double thickness, double length)
+{
+    const double volume_outer_cyl = form_volume(radius,thickness,length);
+    return cbrt(0.75*volume_outer_cyl/M_PI);
+}
+
+static double
+radius_from_diagonal(double radius, double thickness, double length)
+{
+    const double radius_outer = radius + thickness;
+    const double length_outer = length + thickness;
+    return sqrt(radius_outer*radius_outer + 0.25*length_outer*length_outer);
+}
+
+static double
+effective_radius(int mode, double radius, double thickness, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius, thickness, length);
+    } else if (mode == 2) {
+        return radius + thickness;
+    } else if (mode == 3) {
+        return 0.5*length + thickness;
+    } else if (mode == 4) {
+        return (radius < 0.5*length ? radius + thickness : 0.5*length + thickness);
+    } else if (mode == 5) {
+        return (radius > 0.5*length ? radius + thickness : 0.5*length + thickness);
+    } else {
+        return radius_from_diagonal(radius,thickness,length);
+    }
 }
 
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_cylinder.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -126,13 +126,15 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "core_shell_cylinder.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","outer radius","half outer length","half min outer dimension",
+                         "half max outer dimension","half outer diagonal"]
 
-def ER(radius, thickness, length):
-    """
-    Returns the effective radius used in the S*P calculation
-    """
-    radius = radius + thickness
-    length = length + 2 * thickness
-    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+#def ER(radius, thickness, length):
+#    """
+#    Returns the effective radius used in the S*P calculation
+#    """
+#    radius = radius + thickness
+#    length = length + 2 * thickness
+#    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def VR(radius, thickness, length):
Index: sasmodels/models/core_shell_ellipsoid.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_ellipsoid.c	(revision 3c60146f44ec3507ebbe0e1e7c740546e003f5b2)
@@ -36,4 +36,50 @@
     double vol = M_4PI_3*equat_shell*equat_shell*polar_shell;
     return vol;
+}
+
+static double
+radius_from_volume(double radius_equat_core, double x_core, double thick_shell, double x_polar_shell)
+{
+    const double volume_ellipsoid = form_volume(radius_equat_core, x_core, thick_shell, x_polar_shell);
+    return cbrt(0.75*volume_ellipsoid/M_PI);
+}
+
+static double
+radius_from_curvature(double radius_equat_core, double x_core, double thick_shell, double x_polar_shell)
+{
+    // Trivial cases
+    if (1.0 == x_core && 1.0 == x_polar_shell) return radius_equat_core + thick_shell;
+    if ((radius_equat_core + thick_shell)*(radius_equat_core*x_core + thick_shell*x_polar_shell) == 0.)  return 0.;
+
+    // see equation (26) in A.Isihara, J.Chem.Phys. 18(1950)1446-1449
+    const double radius_equat_tot = radius_equat_core + thick_shell;
+    const double radius_polar_tot = radius_equat_core*x_core + thick_shell*x_polar_shell;
+    const double ratio = (radius_polar_tot < radius_equat_tot
+                          ? radius_polar_tot / radius_equat_tot
+                          : radius_equat_tot / radius_polar_tot);
+    const double e1 = sqrt(1.0 - ratio*ratio);
+    const double b1 = 1.0 + asin(e1) / (e1 * ratio);
+    const double bL = (1.0 + e1) / (1.0 - e1);
+    const double b2 = 1.0 + 0.5 * ratio * ratio / e1 * log(bL);
+    const double delta = 0.75 * b1 * b2;
+    const double ddd = 2.0 * (delta + 1.0) * radius_polar_tot * radius_equat_tot * radius_equat_tot;
+    return 0.5 * cbrt(ddd);
+}
+
+static double
+effective_radius(int mode, double radius_equat_core, double x_core, double thick_shell, double x_polar_shell)
+{
+    const double radius_equat_tot = radius_equat_core + thick_shell;
+    const double radius_polar_tot = radius_equat_core*x_core + thick_shell*x_polar_shell;
+
+    if (mode == 1) {
+        return radius_from_volume(radius_equat_core, x_core, thick_shell, x_polar_shell);
+    } else if (mode == 2) {
+        return radius_from_curvature(radius_equat_core, x_core, thick_shell, x_polar_shell);
+    } else if (mode == 3) {
+        return (radius_polar_tot < radius_equat_tot ? radius_polar_tot : radius_equat_tot);
+    } else {
+        return (radius_polar_tot > radius_equat_tot ? radius_polar_tot : radius_equat_tot);
+    }
 }
 
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -146,13 +146,14 @@
 source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "core_shell_ellipsoid.c"]
 have_Fq = True
-
-def ER(radius_equat_core, x_core, thick_shell, x_polar_shell):
-    """
-        Returns the effective radius used in the S*P calculation
-    """
-    from .ellipsoid import ER as ellipsoid_ER
-    polar_outer = radius_equat_core*x_core + thick_shell*x_polar_shell
-    equat_outer = radius_equat_core + thick_shell
-    return ellipsoid_ER(polar_outer, equat_outer)
+effective_radius_type = ["equivalent sphere","average outer curvature", "min outer radius", "max outer radius"]
+
+#def ER(radius_equat_core, x_core, thick_shell, x_polar_shell):
+#    """
+#        Returns the effective radius used in the S*P calculation
+#    """
+#    from .ellipsoid import ER as ellipsoid_ER
+#    polar_outer = radius_equat_core*x_core + thick_shell*x_polar_shell
+#    equat_outer = radius_equat_core + thick_shell
+#    return ellipsoid_ER(polar_outer, equat_outer)
 
 def random():
Index: sasmodels/models/core_shell_parallelepiped.c
===================================================================
--- sasmodels/models/core_shell_parallelepiped.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_parallelepiped.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -25,4 +25,40 @@
         2.0 * length_a * length_b * thick_rim_c;
 #endif
+}
+
+static double
+radius_from_volume(double length_a, double length_b, double length_c,
+                   double thick_rim_a, double thick_rim_b, double thick_rim_c)
+{
+    const double volume_paral = form_volume(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c);
+    return cbrt(0.75*volume_paral/M_PI);
+}
+
+static double
+radius_from_crosssection(double length_a, double length_b, double thick_rim_a, double thick_rim_b)
+{
+    const double area_xsec_paral = length_a*length_b + 2.0*thick_rim_a*length_b + 2.0*thick_rim_b*length_a;
+    return sqrt(area_xsec_paral/M_PI);
+}
+
+static double
+effective_radius(int mode, double length_a, double length_b, double length_c,
+                 double thick_rim_a, double thick_rim_b, double thick_rim_c)
+{
+    if (mode == 1) {
+        return radius_from_volume(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c);
+    } else if (mode == 2) {
+        return 0.5 * (length_a + thick_rim_a);
+    } else if (mode == 3) {
+        return 0.5 * (length_b + thick_rim_b);
+    } else if (mode == 4) {
+        return 0.5 * (length_c + thick_rim_c);
+    } else if (mode == 5) {
+        return radius_from_crosssection(length_a, length_b, thick_rim_a, thick_rim_b);
+    } else if (mode == 6) {
+        return 0.5*sqrt(square(length_a+thick_rim_a) + square(length_b+thick_rim_b));
+    } else {
+        return 0.5*sqrt(square(length_a+thick_rim_a) + square(length_b+thick_rim_b) + square(length_c+thick_rim_c));
+    }
 }
 
Index: sasmodels/models/core_shell_parallelepiped.py
===================================================================
--- sasmodels/models/core_shell_parallelepiped.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_parallelepiped.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -227,16 +227,17 @@
 source = ["lib/gauss76.c", "core_shell_parallelepiped.c"]
 have_Fq = True
-
-
-def ER(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c):
-    """
-        Return equivalent radius (ER)
-    """
-    from .parallelepiped import ER as ER_p
-
-    a = length_a + 2*thick_rim_a
-    b = length_b + 2*thick_rim_b
-    c = length_c + 2*thick_rim_c
-    return ER_p(a, b, c)
+effective_radius_type = ["equivalent sphere","half outer length_a", "half outer length_b", "half outer length_c",
+                         "equivalent circular cross-section","half outer ab diagonal","half outer diagonal"]
+
+#def ER(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c):
+#    """
+#        Return equivalent radius (ER)
+#    """
+#    from .parallelepiped import ER as ER_p
+#
+#    a = length_a + 2*thick_rim_a
+#    b = length_b + 2*thick_rim_b
+#    c = length_c + 2*thick_rim_c
+#    return ER_p(a, b, c)
 
 # VR defaults to 1.0
Index: sasmodels/models/core_shell_sphere.c
===================================================================
--- sasmodels/models/core_shell_sphere.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_sphere.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -3,4 +3,14 @@
 {
     return M_4PI_3 * cube(radius + thickness);
+}
+
+static double
+effective_radius(int mode, double radius, double thickness)
+{
+    if (mode == 1) {
+        return radius + thickness;
+    } else {
+        return radius;
+    }
 }
 
Index: sasmodels/models/core_shell_sphere.py
===================================================================
--- sasmodels/models/core_shell_sphere.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_sphere.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -78,15 +78,16 @@
 source = ["lib/sas_3j1x_x.c", "lib/core_shell.c", "core_shell_sphere.c"]
 have_Fq = True
+effective_radius_type = ["outer radius", "core radius"]
 
 demo = dict(scale=1, background=0, radius=60, thickness=10,
             sld_core=1.0, sld_shell=2.0, sld_solvent=0.0)
 
-def ER(radius, thickness):
-    """
-        Equivalent radius
-        @param radius: core radius
-        @param thickness: shell thickness
-    """
-    return radius + thickness
+#def ER(radius, thickness):
+#    """
+#        Equivalent radius
+#        @param radius: core radius
+#        @param thickness: shell thickness
+#    """
+#    return radius + thickness
 
 def VR(radius, thickness):
Index: sasmodels/models/cylinder.c
===================================================================
--- sasmodels/models/cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/cylinder.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -11,4 +11,34 @@
 {
     return sas_2J1x_x(qab*radius) * sas_sinx_x(qc*0.5*length);
+}
+
+static double
+radius_from_volume(double radius, double length)
+{
+    return cbrt(0.75*radius*radius*length);
+}
+
+static double
+radius_from_diagonal(double radius, double length)
+{
+    return sqrt(radius*radius + 0.25*length*length);
+}
+
+static double
+effective_radius(int mode, double radius, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius, length);
+    } else if (mode == 2) {
+        return radius;
+    } else if (mode == 3) {
+        return 0.5*length;
+    } else if (mode == 4) {
+        return (radius < 0.5*length ? radius : 0.5*length);
+    } else if (mode == 5) {
+        return (radius > 0.5*length ? radius : 0.5*length);
+    } else {
+        return radius_from_diagonal(radius,length);
+    }
 }
 
Index: sasmodels/models/cylinder.py
===================================================================
--- sasmodels/models/cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/cylinder.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -139,11 +139,12 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "cylinder.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","radius","half length","half min dimension","half max dimension","half diagonal"]
 
-def ER(radius, length):
-    """
-        Return equivalent radius (ER)
-    """
-    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+#def ER(radius, length):
+#    """
+#        Return equivalent radius (ER)
+#    """
+#    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def random():
Index: sasmodels/models/ellipsoid.c
===================================================================
--- sasmodels/models/ellipsoid.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/ellipsoid.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -4,4 +4,45 @@
     return M_4PI_3*radius_polar*radius_equatorial*radius_equatorial;
 }
+
+static double
+radius_from_volume(double radius_polar, double radius_equatorial)
+{
+    return cbrt(radius_polar*radius_equatorial*radius_equatorial);
+}
+
+static double
+radius_from_curvature(double radius_polar, double radius_equatorial)
+{
+    // Trivial cases
+    if (radius_polar == radius_equatorial) return radius_polar;
+    if (radius_polar * radius_equatorial == 0.)  return 0.;
+
+    // see equation (26) in A.Isihara, J.Chem.Phys. 18(1950)1446-1449
+    const double ratio = (radius_polar < radius_equatorial
+                          ? radius_polar / radius_equatorial
+                          : radius_equatorial / radius_polar);
+    const double e1 = sqrt(1.0 - ratio*ratio);
+    const double b1 = 1.0 + asin(e1) / (e1 * ratio);
+    const double bL = (1.0 + e1) / (1.0 - e1);
+    const double b2 = 1.0 + 0.5 * ratio * ratio / e1 * log(bL);
+    const double delta = 0.75 * b1 * b2;
+    const double ddd = 2.0 * (delta + 1.0) * radius_polar * radius_equatorial * radius_equatorial;
+    return 0.5 * cbrt(ddd);
+}
+
+static double
+effective_radius(int mode, double radius_polar, double radius_equatorial)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius_polar, radius_equatorial);
+    } else if (mode == 2) {
+        return radius_from_curvature(radius_polar, radius_equatorial);
+    } else if (mode == 3) {
+        return (radius_polar < radius_equatorial ? radius_polar : radius_equatorial);
+    } else {
+        return (radius_polar > radius_equatorial ? radius_polar : radius_equatorial);
+    }
+}
+
 
 static void
Index: sasmodels/models/ellipsoid.py
===================================================================
--- sasmodels/models/ellipsoid.py	(revision 01688448fd87fd51ac83d2d724652266c645773a)
+++ sasmodels/models/ellipsoid.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -169,26 +169,5 @@
 source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "ellipsoid.c"]
 have_Fq = True
-
-def ER(radius_polar, radius_equatorial):
-    # see equation (26) in A.Isihara, J.Chem.Phys. 18(1950)1446-1449
-    ee = np.empty_like(radius_polar)
-    idx = radius_polar > radius_equatorial
-    ee[idx] = (radius_polar[idx] ** 2 - radius_equatorial[idx] ** 2) / radius_polar[idx] ** 2
-    idx = radius_polar < radius_equatorial
-    ee[idx] = (radius_equatorial[idx] ** 2 - radius_polar[idx] ** 2) / radius_equatorial[idx] ** 2
-    valid = (radius_polar * radius_equatorial != 0) & (radius_polar != radius_equatorial)
-    bd = 1.0 - ee[valid]
-    e1 = np.sqrt(ee[valid])
-    b1 = 1.0 + np.arcsin(e1) / (e1 * np.sqrt(bd))
-    bL = (1.0 + e1) / (1.0 - e1)
-    b2 = 1.0 + bd / 2 / e1 * np.log(bL)
-    delta = 0.75 * b1 * b2
-    ddd = 2.0 * (delta + 1.0) * (radius_polar * radius_equatorial**2)[valid]
-
-    r = np.zeros_like(radius_polar)
-    r[valid] = 0.5 * cbrt(ddd)
-    idx = radius_polar == radius_equatorial
-    r[idx] = radius_polar[idx]
-    return r
+effective_radius_type = ["equivalent sphere","average curvature", "min radius", "max radius"]
 
 def random():
Index: sasmodels/models/elliptical_cylinder.c
===================================================================
--- sasmodels/models/elliptical_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/elliptical_cylinder.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -3,4 +3,56 @@
 {
     return M_PI * radius_minor * radius_minor * r_ratio * length;
+}
+
+static double
+radius_from_volume(double radius_minor, double r_ratio, double length)
+{
+    const double volume_ellcyl = form_volume(radius_minor,r_ratio,length);
+    return cbrt(0.75*volume_ellcyl/M_PI);
+}
+
+static double
+radius_from_min_dimension(double radius_minor, double r_ratio, double length)
+{
+    const double rad_min = (r_ratio > 1.0 ? radius_minor : r_ratio*radius_minor);
+    return (rad_min < length ? rad_min : length);
+}
+
+static double
+radius_from_max_dimension(double radius_minor, double r_ratio, double length)
+{
+    const double rad_max = (r_ratio < 1.0 ? radius_minor : r_ratio*radius_minor);
+    return (rad_max > length ? rad_max : length);
+}
+
+static double
+radius_from_diagonal(double radius_minor, double r_ratio, double length)
+{
+    const double radius_max = (r_ratio > 1.0 ? radius_minor*r_ratio : radius_minor);
+    return sqrt(radius_max*radius_max + 0.25*length*length);
+}
+
+static double
+effective_radius(int mode, double radius_minor, double r_ratio, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius_minor, r_ratio, length);
+    } else if (mode == 2) {
+        return 0.5*radius_minor*(1.0 + r_ratio);
+    } else if (mode == 3) {
+        return (r_ratio > 1.0 ? radius_minor : r_ratio*radius_minor);
+    } else if (mode == 4) {
+        return (r_ratio < 1.0 ? radius_minor : r_ratio*radius_minor);
+    } else if (mode == 5) {
+        return sqrt(radius_minor*radius_minor*r_ratio);
+    } else if (mode == 6) {
+        return 0.5*length;
+    } else if (mode == 7) {
+        return radius_from_min_dimension(radius_minor,r_ratio,length);
+    } else if (mode == 8) {
+        return radius_from_max_dimension(radius_minor,r_ratio,length);
+    } else {
+        return radius_from_diagonal(radius_minor,r_ratio,length);
+    }
 }
 
Index: sasmodels/models/elliptical_cylinder.py
===================================================================
--- sasmodels/models/elliptical_cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/elliptical_cylinder.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -123,4 +123,6 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "elliptical_cylinder.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","average radius","min radius","max radius",
+                         "equivalent circular cross-section","half length","half min dimension","half max dimension","half diagonal"]
 
 demo = dict(scale=1, background=0, radius_minor=100, axis_ratio=1.5, length=400.0,
@@ -128,15 +130,15 @@
             theta_pd=10, phi_pd=2, psi_pd=3)
 
-def ER(radius_minor, axis_ratio, length):
-    """
-        Equivalent radius
-        @param radius_minor: Ellipse minor radius
-        @param axis_ratio: Ratio of major radius over minor radius
-        @param length: Length of the cylinder
-    """
-    radius = sqrt(radius_minor * radius_minor * axis_ratio)
-    ddd = 0.75 * radius * (2 * radius * length
-                           + (length + radius) * (length + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+#def ER(radius_minor, axis_ratio, length):
+#    """
+#        Equivalent radius
+#        @param radius_minor: Ellipse minor radius
+#        @param axis_ratio: Ratio of major radius over minor radius
+#        @param length: Length of the cylinder
+#    """
+#    radius = sqrt(radius_minor * radius_minor * axis_ratio)
+#    ddd = 0.75 * radius * (2 * radius * length
+#                           + (length + radius) * (length + pi * radius))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def random():
